Codeforces-632D Longest Subsequence

You are given array a with n elements and the number m. Consider some subsequence of a and the value of least common multiple (LCM) of its elements. Denote LCM as l. Find any longest subsequence of a with the value l ≤ m.

A subsequence of a is an array we can get by erasing some elements of a. It is allowed to erase zero or all elements.

The LCM of an empty array equals 1.

Input

The first line contains two integers n and m (1 ≤ n, m ≤ 106) — the size of the array a and the parameter from the problem statement.

The second line contains n integers ai (1 ≤ ai ≤ 109) — the elements of a.

Output

In the first line print two integers l and kmax (1 ≤ l ≤ m, 0 ≤ kmax ≤ n) — the value of LCM and the number of elements in optimal subsequence.

In the second line print kmax integers — the positions of the elements from the optimal subsequence in the ascending order.

Note that you can find and print any subsequence with the maximum length.

Examples
input
7 8
6 2 9 2 7 2 3
output
6 5
1 2 4 6 7
input
6 4
2 2 2 3 3 3
output
2 3
1 2 3

题目大意:

给你一个具有n个元素的序列a以及一个数m,找出能够使得所有子序列中最长的一个子序列,并使其满足该子序列的最小公倍数<=m。

解题思路:

这个题目在codeforces里面被归在了暴力(brute force),数学(math),数论(number theory)下,其实感觉就是一个思维题,不过是挺暴力的= =对于整个序列里的每一个元素,只要是大于m的就不需要考虑直接跳过,因为两个数a和b的最小公倍数lcm,必然是大于或者等于a或b的,那么对于所有小于等于m的元素,只需要把所有小于m的元素的因子找到,并且更新因子的个数,找到最终小于m的元素中,具有相同因子个数最多的元素,就是所找到的l,然后再对原数组遍历一遍,找到他的因子们的位置,就可以了。

#include <cstdio>
#include <cstring>
using namespace std;
const int maxn = 1e6 + 5;
int num[maxn], a[maxn], sum[maxn];
int main()
{
	int n, m;
	scanf("%d%d", &n, &m);
	memset(num, 0, sizeof(num));
	memset(sum, 0, sizeof(sum));
	for(int i = 0; i < n; ++i){
		scanf("%d", &a[i]);
		if(a[i] <= m){
			++num[a[i]];
		}
	}
	for(int i = 1; i <= m; ++i){
		if(num[i]){
			for(int j = i; j <= m; j += i){
				sum[j] += num[i];
			}
		}
	}
	int max_sum = 0, max_val = 0;
	for(int i = 1; i <= m; ++i){
		if(sum[i] && max_sum < sum[i]){
			max_val = i;
			max_sum = sum[i];
		}
	}
	if(max_sum == 0){
		printf("1 0\n\n");
	}else{
		int cas = 0;
		printf("%d %d\n", max_val, max_sum);
		for(int i = 0; i < n; ++i){
			if(max_val % a[i] == 0){
				if(cas){
					printf(" ");
				}
				printf("%d", i + 1);
				++cas;
			}
		}
		puts("");
	}
	return 0;
}
如有错误,还请各位菊苣指出!

CodeForces - 616D是一个关于找到一个序列中最长的第k好子段的起始位置和结束位置的问题。给定一个长度为n的序列和一个整数k,需要找到一个子段,该子段中不超过k个不同的数字。题目要求输出这个序列最长的第k好子段的起始位置和终止位置。 解决这个问题的方法有两种。第一种方法是使用尺取算法,通过维护一个滑动窗口来记录\[l,r\]中不同数的个数。每次如果这个数小于k,就将r向右移动一位;如果已经大于k,则将l向右移动一位,直到个数不大于k。每次更新完r之后,判断r-l+1是否比已有答案更优来更新答案。这种方法的时间复杂度为O(n)。 第二种方法是使用枚举r和双指针的方法。通过维护一个最小的l,满足\[l,r\]最多只有k种数。使用一个map来判断数的种类。遍历序列,如果当前数字在map中不存在,则将种类数sum加一;如果sum大于k,则将l向右移动一位,直到sum不大于k。每次更新完r之后,判断i-l+1是否大于等于y-x+1来更新答案。这种方法的时间复杂度为O(n)。 以上是两种解决CodeForces - 616D问题的方法。具体的代码实现可以参考引用\[1\]和引用\[2\]中的代码。 #### 引用[.reference_title] - *1* [CodeForces 616 D. Longest k-Good Segment(尺取)](https://blog.youkuaiyun.com/V5ZSQ/article/details/50750827)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] - *2* [Codeforces616 D. Longest k-Good Segment(双指针+map)](https://blog.youkuaiyun.com/weixin_44178736/article/details/114328999)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] [ .reference_list ]
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值